<template>
  <div>
    <div>
<CModal
      title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>

<CCardBody>
     <h5>Trace Hold Reason </h5>
    
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
      sorter
     >
      <!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectHoldReason(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectHoldReason(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectHoldReason(item)"> Details </CButton>
    </template>
    </CDataTable>
  <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> New Hold Reason</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title"> New Hold Reason</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">


<div class="form-group"><label  >Hold Reason</label>
<input type="text" name="mhE_Name" class="form-control form-control-sm"  v-model="newHoldEntry.hold_Reason">
</div>

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addHoldReason(); " > Add Hold Reason </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Hold Reason</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">

<div class="form-group"><label  > Id</label>
<input type="text" name="mhE_Id" readonly class="form-control form-control-sm"  v-model="Currentreason.hold_Reason_Id">
</div>

<div class="form-group"><label  >Hold Reason</label>
<input type="text" name="mhE_Name" readonly class="form-control form-control-sm"  v-model="Currentreason.hold_Reason">
</div>




<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update </h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group"><label  > Id</label>
<input type="text" name="mhE_Id" readonly class="form-control form-control-sm"  v-model="Currentreason.hold_Reason_Id">
</div>



<div class="form-group"><label  >Hold Reason</label>
<input type="text" name="mhE_Type" class="form-control form-control-sm"   v-model="newHoldEntry.hold_Reason">
</div> 

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false; UpdateHoldReason();" > Update </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete </h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Hold Reason ? </h4>
<h5> You are deleting {{ this.Currentreason.hold_Reason_Id +' || '+ this.Currentreason.hold_Reason }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem(); "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>
<script>
const apiurl =  'Trace_Hold_Reasons/'
const items = [
  { key: 'hold_Reason_Id', _style:'min-width:200px' },
  { key: 'hold_Reason', _style:'min-width:100px;' },
 
 ]   
  
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
              { key: 'hold_Reason_Id' , label: ' Id',},
              { key: 'hold_Reason', label: 'Hold Code', },
             { key: 'show_details',  label: '',  _style: 'width:30%', },     
                 
      ],
  Currentreason:"",
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
 
  newHoldEntry: {hold_Reason_Id:0,hold_Reason:"",hold_Reason_status:1,}, }
  },
 

  
  mounted()
  {
   this.getAllHoldReasons();
  },

  methods:
  {
   getAllHoldReasons: function()
   {
    Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
       {
        this.items =response.data.filter(x => x.hold_Reason_status == 1);
       // this.subitems = response.data.fgS_FIFO_HoldEntry_Type_Master;

       }
    });
   },
  
  SelectHoldReason(holdreason)
    {
     this.Currentreason=holdreason;
      
    },
       
  addHoldReason()
  {


if(this.newHoldEntry.hold_Reason == "" )

{
   this.SuccessMsg = "Please enter all fields";
  this.smallModal = true;
  this.ShowAddModal = true;
    
}
 else if(this.items.find(x => x.hold_Reason == this.newHoldEntry.hold_Reason && x.hold_Reason_status == 1 ))
     {
      
       this.SuccessMsg=  this.newHoldEntry.hold_Reason +" already exist. ";
       this.smallModal = true;
        this.ShowAddModal = true;
      }
    
    else
     {
      
       Vue.axios.post(this.$url + apiurl ,this.newHoldEntry).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        location.reload();
       this.getAllHoldReasons();
       }
      })
     }
   },
 
 UpdateHoldReason()
  {
    

   
      
    if((this.Currentreason.hold_Reason != this.newHoldEntry.hold_Reason ) && this.items.find(x => x.hold_Reason == this.newHoldEntry.hold_Reason && x.hold_Reason_status == 1 ))
      {
       
       this.SuccessMsg= "Hold Reason " + this.newHoldEntry.hold_Reason +" already exist.";
       this.smallModal = true;
     }
   
   else if(this.newHoldEntry.hold_Reason == "" )
    {
 
    this.SuccessMsg = "Please enter all the fields";
    this.smallModal = true;
    }
    else
     {
       
       this.newHoldEntry.hold_Reason_Id = this.Currentreason.hold_Reason_Id
       //alert(this.newHoldEntry.hold_Reason_Id)
       Vue.axios.put(this.$url + apiurl + this.newHoldEntry.hold_Reason_Id,this.newHoldEntry).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllHoldReasons();
         response.reload();
       }
    })
   }
   
   },

  deleteItem()
    {
      var hold_Reason_Id = this.Currentreason.hold_Reason_Id;
        axios({   method: 'delete',
           url: this.$url + apiurl+ hold_Reason_Id
    });
        this.SuccessMsg=" Status Changed to Inactive Succesfully"
        this.smallModal = true;
       
         this.getAllHoldReasons();
          location.reload();
    },
      
  
    },
  
    }
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>